petsc-3.10.5 2019-03-28
Report Typos and Errors

# TSSetForcingFunction

Provide a function that computes a forcing term for a ODE or PDE

### Synopsis

    #include "petscts.h"
    PetscErrorCode  TSSetForcingFunction(TS ts,TSForcingFunction func,void *ctx)

Logically Collective on TS

### Input Parameters

| ts | - the TS context obtained from TSCreate()
| func | - routine for evaluating the forcing function
| ctx | - [optional] user-defined context for private data for the function evaluation routine (may be NULL)

### Calling sequence of func

        func (TS ts,PetscReal t,Vec f,void *ctx);

| t | - current timestep
| f | - output vector
| ctx | - [optional] user-defined function context

### Notes

This routine is useful for testing accuracy of time integration schemes when using the Method of Manufactured Solutions to create closed-form solutions with a non-physical forcing term. It allows you to use the Method of Manufactored Solution without directly editing the definition of the problem you are solving and hence possibly introducing bugs.

This replaces the ODE F(u,u_t,t) = 0 the TS is solving with F(u,u_t,t) - func(t) = 0

This forcing function does not depend on the solution to the equations, it can only depend on spatial location, time, and possibly parameters, the parameters can be passed in the ctx variable.

For low-dimensional problems solved in serial, such as small discrete systems, TSMonitorLGError() can be used to monitor the error history.

### Keywords

TS, timestep, set, right-hand-side, function

### See Also

TSSetRHSJacobian(), TSSetIJacobian(), TSComputeSolutionFunction(), TSSetSolutionFunction()

### Level

beginner

### Location

src/ts/interface/ts.c
Index of all TS routines
Table of Contents for all manual pages
Index of all manual pages